<template>
 <v-page :header-text="headerText">
    <div class="email-sent-page-container">
      Email was sent to:
      <div class="email">{{ email }}</div>
      <v-button :in-progress="inProgress" @click="onResend">Resend email</v-button>
      <FormErrorMessage v-if="error">{{ error }}</FormErrorMessage>
      <br/>
      <v-button-link to="/user-auth">back</v-button-link>
    </div>
  </v-page>
</template>

<script>
  import { createNamespacedHelpers } from 'vuex'

  import { VButton } from 'zeus-common'
  import { VButtonLink } from 'zeus-common'
  import { VPage } from 'zeus-common'
  import { FormErrorMessage } from 'zeus-common'
  import { EmailSentService } from '@/common/email-sent/service'
  import { header as headerText } from '@/config'

  const { mapState } = createNamespacedHelpers('confirmationEmailSent')

  export default {
    name: 'ConfirmationEmailSentPage',
    components: { FormErrorMessage, VPage, VButtonLink, VButton },
    data: () => ({
      headerText: headerText
    }),
    computed: {
      ...mapState([ 'inProgress', 'error', 'email', 'pass' ])
    },
    async mounted() {
      if (!this.email) {
        this.$router.push('user-auth')
      }
      this.emailConfirmationDeferred = EmailSentService.waitForEmailConfirmation(this.email, this.pass)
      try {
        await this.emailConfirmationDeferred
        this.$router.push('/email-confirmed')
      } catch (e) {
        // ignore
      }
    },
    beforeDestroy() {
      if (this.emailConfirmationDeferred) {
        this.emailConfirmationDeferred.cancel()
      }
      this.$store.commit('confirmationEmailSent/reset')
    },
    methods: {
      onResend() {
        this.$store.dispatch('confirmationEmailSent/resendConfirmationEmail', this.email)
      }
    }
  }
</script>

<style scoped lang="scss">
  .email-sent-page-container {
    margin-top: 3.5em;

    .email {
      color: #585688;
      font-weight: 500;
      margin: 1.2em 0 2.1em;
    }
  }
</style>